# Various IRT models using eRm

#----------------- dichotomous models ---------------------

#Simple ICC plotting
ppar <- sort(runif(100, -3, 3))
itdiff <- 0.5                     #item difficulty fixed to 0.5

numer <- exp(ppar - itdiff)       #numerator Rasch expression
denom <- 1 + exp(ppar - itdiff)   #denominator Rasch expression
iccval <- numer/denom
plot(ppar, iccval, main = "Simulated ICC")

#Rasch model
library("eRm")
data("raschdat1")

res.rasch <- RM(raschdat1)
res.rasch
summary(res.rasch)
person.parameter(res.rasch)
plotjointICC(res.rasch, item.subset = 1:8)

#------------------- polytomous models --------------------
data("rsmdat")

#Rating scale model
res.rsm <- RSM(rsmdat)

#Partial credit model
res.pcm <- PCM(rsmdat)

plotICC(res.rsm, item.subset = 1:4, xlab = "RSM ICC", mplot = TRUE, legpos = FALSE)
dev.new()
plotICC(res.pcm, item.subset = 1:4, xlab = "PCM ICC", mplot = TRUE, legpos = FALSE)

data("pcmdat")
res.pcm2 <- PCM(pcmdat)
plotICC(res.pcm2, item.subset = 1:4, xlab = "PCM ICC", mplot = TRUE, legpos = FALSE)
thresholds(res.pcm2)
